#ifndef _KILIB_KTL_ARRAY_H
#define _KILIB_KTL_ARRAY_H
namespace kilib{


//-------------------------------------------------------------------------
//@{
//	ȈՉϔz
//
//	vf̒ǉ͖ւ̂݁B
//	kForceSizeł̋ύX̂݁B
//	ANZX͍DȂƂ֎RɁB
//	Cӈʒuł̑}/폜KvȂgapbufgƁB
//@}
//-------------------------------------------------------------------------

template <class T>
class array
{
public:

	//@{
	//	RXgN^
	//	@param alloc_size mۂ鏉TCYB
	//@}
	explicit array( ulong alloc_size=20 )
	{
		if( alloc_size==0 )
		{
			alloc_size = 1;
		}
		m_pData = new T[ m_ALen=alloc_size ];
		m_Len   = 0;
	}

	//@{
	//	fXgN^
	//@}
	~array()
	{
		delete [] m_pData;
	}

	//@{ z̗vf𓾂 //@}
	ulong size() const
		{ return m_Len; }

	//@{ vf擾 //@}
	T& operator[]( ulong i )
		{ return m_pData[i]; }

	//@{ vf擾 //@}
	const T& operator[]( ulong i ) const
		{ return m_pData[i]; }

	//@{ vf擾 //@}
	T& get( ulong i )
		{ return m_pData[i]; }

	//@{ vf擾 //@}
	const T& get( ulong i ) const
		{ return m_pData[i]; }


	//@{
	//	SvffXgNg
	//@}
	void Clear()
	{
		ForceSize( 0 );
		Allocate( m_ALen );
	}

	//@{
	//	ɗvfǉ
	//@}
	void Add( const T& obj )
	{
		if( m_Len >= m_ALen )
		{
			Allocate( m_ALen<<1 );
		}
		m_pData[ m_Len++ ] = obj;
	}

	//@{
	//	zTCYύX
	//@}
	void ForceSize( ulong new_size )
	{
		if( new_size > m_ALen )
		{
			Allocate( new_size );
		}
		m_Len = new_size;
	}

	//@{
	//	zۂƃRs[
	//@}
	array<T>& operator=( const array<T>& o )
	{
		if( &o != this )
		{
			Clear();
			for( ulong i=0,max=o.size(); i<max; i++ )
				Add( o[i] );
		}
		return *this;
	}

protected:

	void Allocate( ulong siz )
	{
		T* p = new T[ m_ALen=siz ];
		for( ulong i=0; i<m_Len; i++ )
			p[i] = m_pData[i];
		delete [] m_pData;
		m_pData = p;
	}

	T* m_pData;
	ulong m_Len, m_ALen;
};


//-------------------------------------------------------------------------
//@{
//	array + autoptr
//@}
//-------------------------------------------------------------------------


template <class T>
class arrayptr : public array< autoptr<T> >
{
public:
	explicit arrayptr( ulong alloc_size=10 )
		: array< autoptr<T> >( alloc_size )
	{
	}

	void Add( const T* obj )
	{
		array< autoptr<T> >::Add( autoptr<T>(obj) );
	}

private:
	arrayptr<T>& operator=( const arrayptr<T>& o );
};


};     // namespace kilib
#endif // _KILIB_KTL_ARRAY_H
