//
// kilib/wnd.cpp : Base Window/Dialog Class
//

#include "stdafx.h"
#include "kilib.h"
namespace kilib {


//-------------------------------------------------------------------------


// USERDATÄWnd*L^鏈̂߂ɁA
// tbNĂB
// ATL݂"TN"ƂgƗǂ炢
// ǁA悭킩ȂcB

HHOOK Wnd::s_hHook    = NULL;
Wnd*  Wnd::s_pCurInit = NULL;
	
void Wnd::InitWndLib()
{
	s_hHook = ::SetWindowsHookEx(
		WH_CBT, &CBTProc, NULL, ::GetCurrentThreadId() );
}

void Wnd::FinishWndLib()
{
	::UnhookWindowsHookEx( s_hHook );
}

LRESULT CALLBACK Wnd::CBTProc( int code, WPARAM wp, LPARAM lp )
{
	if( code==HCBT_CREATEWND && s_pCurInit!=NULL )
	{
		::SetWindowLong(
			s_pCurInit->m_hWnd = reinterpret_cast<HWND>(wp),
			GWL_USERDATA, reinterpret_cast<LONG>(s_pCurInit)
		);
		s_pCurInit = NULL;
	}
	return ::CallNextHookEx( s_hHook, code, wp, lp );
}


//-------------------------------------------------------------------------


//   WndhNX́ÃEChE钼O
//   Ăł˂΂ȂȂB

void Wnd::PreCreate( Wnd* wnd )
{
	s_pCurInit = wnd;
}

//   WndhNX́AWM_DESTROY
//   Ăł˂΂ȂȂB

void Wnd::DetachHwnd()
{
	::SetWindowLong( m_hWnd, GWL_USERDATA, 0 );
	m_hWnd = NULL;

	if( this == app().wnd() )
	{
		app().SetMainWnd( NULL );
		::PostQuitMessage( 0 );
	}
}


//-------------------------------------------------------------------------


void Wnd::SetFront( HWND hwnd )
{
	// kazubon TClock ̃\[XQlɂ܂B

	static const OSVERSIONINFO& v = util::osver();

	if( ( v.dwPlatformId==VER_PLATFORM_WIN32_NT && v.dwMajorVersion>=5 )
	 || ( v.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS &&
	          v.dwMajorVersion*100+v.dwMinorVersion>=410 ) )
	{
		DWORD pid;
		HWND  fore= ::GetForegroundWindow();
		DWORD th1 = ::GetWindowThreadProcessId( fore, &pid );
		DWORD th2 = ::GetCurrentThreadId();
		::AttachThreadInput( th2, th1, TRUE );
		::SetForegroundWindow( hwnd );
		::AttachThreadInput( th2, th1, FALSE );
		::BringWindowToTop( hwnd );
	}
	else
	{
		::SetForegroundWindow( hwnd );
	}
}

void Wnd::SetCenter( HWND hwnd, HWND rel )
{
	RECT rc,pr;
	::GetWindowRect( hwnd, &rc );

	if( rel != NULL )
	{
		::GetWindowRect( rel, &pr );
	}
	else
	{
		::SystemParametersInfo( SPI_GETWORKAREA, 0, &pr, 0 );
	}

	::SetWindowPos( hwnd, 0,
		pr.left + ( (pr.right-pr.left)-(rc.right-rc.left) )/2,
		pr.top  + ( (pr.bottom-pr.top)-(rc.bottom-rc.top) )/2,
		0, 0, SWP_NOSIZE|SWP_NOZORDER );
}

static void CALLBACK timeout_mb( HWND,UINT,UINT,DWORD )
{
	::PostQuitMessage( 0 );
}

int Wnd::MsgBoxCoreRoutine(
		HWND wnd, LPCTSTR msg, LPCTSTR caption, UINT type, int timeout )
{
	// MicrosoftKnowledge BasẻԂiYꂽ(^^;jQlɂ܂B

	UINT id;
	if( timeout != -1 )
	{
		id = ::SetTimer( NULL, 0, timeout, (TIMERPROC)timeout_mb );
		type &= ~MB_TASKMODAL;
	}
	int ans = ::MessageBox( wnd, msg, caption, type );
	if( timeout != -1 )
	{
		::KillTimer( NULL, id );

		MSG msg;
		if( ::PeekMessage( &msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE ) )
		{
			ans = IDTIMEOUT;
			if( wnd )
			{
				do
				{
					if( ::GetWindowLong( wnd, GWL_STYLE ) & WS_CHILD )
					{
						wnd = ::GetParent( wnd );
					}
					else
					{
						EnableWindow( wnd, TRUE );
						Wnd::SetFront( wnd );
						wnd = NULL;
					}
				} while( wnd != NULL );
			}
		}
	}
	return ans;
}


//-------------------------------------------------------------------------


Wnd::Wnd() : m_hWnd( NULL )
{
}

Wnd::~Wnd()
{
	if( m_hWnd!=NULL && ::IsWindow( m_hWnd ) )
	{
		::SetWindowLong( m_hWnd, GWL_USERDATA, 0 );
		::DestroyWindow( m_hWnd );
	}
}

bool Wnd::TrnsAccel( MSG* msg )
{
	return false;
}


//-------------------------------------------------------------------------


HWND Wnd::hwnd() const
{
	return m_hWnd;
}

Wnd* Wnd::wndptr( HWND hwnd )
{
	Wnd* ptr = wndptr_direct( hwnd );
	if( ptr==NULL
	 || ::IsBadReadPtr((FARPROC)&ptr->m_hWnd,4)
	 || ptr->m_hWnd!=hwnd )
	{
		return NULL;
	}
	return ptr;
}

Wnd* Wnd::wndptr_direct( HWND hwnd )
{
	// direct̓̕G[`FbNB
	return reinterpret_cast<Wnd*>(::GetWindowLong( hwnd, GWL_USERDATA ));
}


//-------------------------------------------------------------------------


void Wnd::ShowUp()
{
	const HWND h = hwnd();
	::ShowWindow( h, SW_SHOW );
	::UpdateWindow( h );
}

LRESULT Wnd::SendMsg( UINT msg, WPARAM wp, LPARAM lp )
{
	return ::SendMessage( hwnd(), msg, wp, lp );
}

BOOL Wnd::PostMsg( UINT msg, WPARAM wp, LPARAM lp )
{
	return ::PostMessage( hwnd(), msg, wp, lp );
}

int Wnd::MsgBox( LPCTSTR msg, LPCTSTR caption, UINT type, int timeout ) const
{
	// eɃbZ[W{bNX쐬B
	return MsgBoxCoreRoutine( hwnd(), msg, caption, type, timeout );
}

bool Wnd::alive() const
{
	if( m_hWnd==NULL )
		return false;
	if( ::IsWindow(m_hWnd) )
		return true;
	m_hWnd = NULL;
	return false;
}


//-------------------------------------------------------------------------


void Wnd::MsgLoop()
{
	// thisSŃbZ[W[v񂷁B
	// kilib̂悤loopbreaker͍̂ƂlĂȂB

	for( MSG msg; ::GetMessage( &msg,NULL,0,0 ); )
	{
		if( TrnsAccel( &msg ) || IsDlgMsg( &msg ) )
		{
			continue;
		}
		::TranslateMessage( &msg );
		::DispatchMessage( &msg );
	}
}

void Wnd::ProcessMsg()
{
	for( MSG msg; ::PeekMessage( &msg,NULL,0,0,PM_REMOVE ); )
	{
		::TranslateMessage( &msg );
		::DispatchMessage( &msg );
	}
}


//-------------------------------------------------------------------------


Window::Window( LPCTSTR className, DWORD style, DWORD styleEx )
	: m_className( className ), m_style( style ), m_styleEx( styleEx )
{
}

bool Window::Create( LPCTSTR wndName, int x, int y, int w, int h, HWND parent )
{
	PreCreate( this );
	return (NULL != ::CreateWindowEx( m_styleEx, m_className, wndName, m_style,
							x, y, w, h, parent, NULL, app().hinst(), NULL ));
}


ATOM Window::MyRegisterClassEx( WNDCLASSEX* cls )
{
	// WindowhNXŎgWndClasso^B
	// vV[Wkilibސ̂̂ɏႢ܂B
	cls->cbSize      = sizeof(WNDCLASSEX);
	cls->hInstance   = app().hinst();
	cls->lpfnWndProc = CommonProc;
	return ::RegisterClassEx( cls );
}


//-------------------------------------------------------------------------


void Window::on_init()		{}
void Window::on_destroy()	{}
bool Window::on_command( UINT id, HWND ctrl ){return false;}
LRESULT Window::on_message( UINT msg, WPARAM wp, LPARAM lp )
{
	return ::DefWindowProc( hwnd(), msg, wp, lp );
}


//-------------------------------------------------------------------------


LRESULT CALLBACK Window::CommonProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
{
	// dynamic_cast<cWnd*>...
	Window* ptr = (Window*)wndptr_direct( hwnd );
	if( ptr==NULL )
	{
		return ::DefWindowProc( hwnd, msg, wp, lp );
	}

	switch( msg )
	{
	case WM_CREATE:
		ptr->on_init();
		break;
	case WM_DESTROY:
		ptr->on_destroy();
		ptr->DetachHwnd();
		break;
	case WM_COMMAND:
		if( !ptr->on_command( LOWORD(wp), (HWND)lp ) )
		{
			return ::DefWindowProc( hwnd, msg, wp, lp );
		}
		break;
	default:
		return ptr->on_message( msg, wp, lp );
	}
	return 0;
}

bool Window::IsDlgMsg( MSG* msg )
{
	// _CAOȂ̂ŏ܂
	return false;
}


//-------------------------------------------------------------------------


Dlg::Dlg( UINT id ) : m_Rsrc( id )
{
}


//-------------------------------------------------------------------------


HWND Dlg::item( UINT id )
{
	return ::GetDlgItem( hwnd(), id );
}

LRESULT Dlg::SendMsgToItem( UINT id, UINT msg, WPARAM wp, LPARAM lp )
{
	return ::SendDlgItemMessage( hwnd(), id, msg, wp, lp );
}

void Dlg::End( UINT code )
{
	SetEndCode( code );
	if( type() == MODAL )
	{
		::EndDialog( hwnd(), code );
	}
	else
	{
		::DestroyWindow( hwnd() );
	}
}


//-------------------------------------------------------------------------
// IɎgc


void Dlg::SetEndCode( UINT endcode )
{
	m_EndCode = endcode;
}

Dlg::dlgtype Dlg::type() const
{
	return m_fType;
}

void Dlg::SetType( dlgtype tp )
{
	m_fType = tp;
}

UINT Dlg::rsrcID() const
{
	return m_Rsrc;
}


//-------------------------------------------------------------------------


void Dlg::GoModal( HWND parent )
{
	SetType( MODAL );
	PreCreate( this );

	::DialogBox( app().hinst(), MAKEINTRESOURCE(m_Rsrc), parent, CommonProc );
}

void Dlg::GoModeless( HWND parent )
{
	SetType( MODELESS );
	PreCreate( this );

	::CreateDialog( app().hinst(), MAKEINTRESOURCE(m_Rsrc), parent, CommonProc );
	ShowUp();
}

UINT Dlg::endcode() const
{
	return m_EndCode;
}


//-------------------------------------------------------------------------


void Dlg::on_init()    {}
void Dlg::on_destroy() {}
bool Dlg::on_ok()    {return true;}
bool Dlg::on_cancel(){return true;}
bool Dlg::on_command( UINT cmd, UINT id, HWND ctrl )  {return false;}
bool Dlg::on_message( UINT msg, WPARAM wp, LPARAM lp ){return false;}


//-------------------------------------------------------------------------


BOOL CALLBACK Dlg::CommonProc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
{
	// dynamic_cast<Dlg*>...
	Dlg* ptr = (Dlg*)wndptr_direct( dlg );
	if( ptr==NULL )
	{
		return FALSE;
	}

	switch( msg )
	{
	case WM_INITDIALOG:
		ptr->on_init();
		return FALSE;

	case WM_DESTROY:
		ptr->on_destroy();
		ptr->DetachHwnd();
		return FALSE;

	case WM_COMMAND:
		switch( LOWORD(wp) )
		{
		case IDOK:
			if( ptr->on_ok() )
			{
				ptr->End( IDOK );
			}
			return TRUE;
		case IDCANCEL:
			if( ptr->on_cancel() )
			{
				ptr->End( IDCANCEL );
			}
			return TRUE;
		default:
			return ptr->on_command( HIWORD(wp), LOWORD(wp), (HWND)lp )
				? TRUE : FALSE;
		}

	default:
		return ptr->on_message( msg, wp, lp ) ? TRUE : FALSE;
	}
}

bool Dlg::IsDlgMsg( MSG* msg )
{
	// [hX̎pB_CAObZ[WB
	return (FALSE != ::IsDialogMessage( hwnd(), msg ));
}


//-------------------------------------------------------------------------


};     // namespace kilib
