
#include "stdafx.h"
#include "rsrc/resource.h"
#include "kilib/kilib.h"
using namespace kilib;


//---------------------------------------------------------------------


#define addslash( p )    {if(*::CharPrev(p,p+::lstrlen(p))!='\\')::lstrcat(p,"\\");}
#define strsame( a, b )  (0==::lstrcmp((a),(b)))
#define strsamei( a, b ) (CSTR_EQUAL==::CompareString(LOCALE_USER_DEFAULT,NORM_IGNORECASE|SORT_STRINGSORT,(a),-1,(b),-1))

enum {
	DLL_BEGIN=0,
	UNLHA=0,
	UNZIP,
	UNARJ,
	UNRAR,
	CAB,
	ZIP,
	TAR,
	ISH,
	FTP,
	UNKANJ,
	JACK,
	BGA,
	UNBEL,
	AISH,
	AISHMV,
	UNYZ1,
	YZ1,
	YYZ,
	DMISH,
	JAM,
	UNJAM,
	UNGCA,
	SvZip,
	WINEX,
	DLL_END
};

static const char* g_DllNameList[] = {
	"Unlha32.dll",
	"UnZip32.dll",
	"Unarj32j.dll",
	"Unrar32.dll",
	"Cab32.dll",
	"Zip32j.dll",
	"Tar32.dll",
	"Ish32.dll",
	"Ftp32.dll",
	"Unkanj.dll",
	"Jack32.dll",
	"Bga32.dll",
	"Unbel32.dll",
	"Aish32.dll",
	"Aishmv32.dll",
	"Unyz1.dll",
	"Yz1.dll",
	"Yyz32.dll",
	"DmIsh32.dll",
	"Jam32.dll",
	"Unjam32.dll",
	"UnGCA32.dll",
	"7-zip32.dll",
	"WinEx32.dll",
	""
};

static const char* g_ApiNameList[] = {
	"Unlha",
	"UnZip",
	"Unarj",
	"Unrar",
	"Cab",
	"Zip",
	"Tar",
	"Ish",
	"Ftp",
	"ccCommand",
	"Jack",
	"Bga",
	"Unbel",
	"Aish",
	"Aishmv",
	"UnYz1",
	"Yz1",
	"Yz1",
	"Ish",
	"Jam",
	"Unjam",
	"UnGCA",
	"SevenZip",
	"WinExGetInfo",
	""
};

typedef int  (WINAPI * DLL_CMD)(const HWND,LPCSTR,LPSTR,const DWORD);
typedef int  (WINAPI * DLL_ISH)(const HWND,LPCSTR);
typedef WORD (WINAPI * DLL_VER)(void);
typedef BOOL (WINAPI * DLL_CHK)(const char*,const int);
typedef BOOL (WINAPI * DLL_DLG)(HWND,LPSTR,int);
struct GmdInfo{
	char szFileEx[512];
	char szExInfo1[256];
	char szExInfo2[512];
};
typedef int  (WINAPI * GMD_INF)(LPCSTR,int,GmdInfo*,DWORD);
typedef int  (WINAPI * GMD_VER)();
typedef int  (WINAPI * GMD_CRC)(LPCSTR);

static const char* error2str( int result )
{
	switch( result )
	{
	case 0x0000:return "OK";
	case 0x8005:return "WARNING_DISK_SPACE";
	case 0x8006:return "WARNING_READ_ONLY";
	case 0x8007:return "WARNING_USER_SKIP";
	case 0x8008:return "WARNING_UNKNOWN_TYPE";
	case 0x8009:return "WARNING_METHOD";
	case 0x800A:return "WARNING_PASSWORD_FILE";
	case 0x800B:return "WARNING_VERSION";
	case 0x800C:return "WARNING_FILE_CRC";
	case 0x800D:return "WARNING_FILE_OPEN";
	case 0x800E:return "WARNING_MORE_FRESH";
	case 0x800F:return "WARNING_NOT_EXIST";
	case 0x8010:return "WARNING_ALREADY_EXIST";
	case 0x8011:return "WARNING_TOO_MANY_FILES";
	case 0x8012:return "ERROR_MAKEDIRECTORY";
	case 0x8013:return "ERROR_CANNOT_WRITE";
	case 0x8014:return "ERROR_HUFFMAN_CODE";
	case 0x8015:return "ERROR_COMMENT_HEADER";
	case 0x8016:return "ERROR_HEADER_CRC";
	case 0x8017:return "ERROR_HEADER_BROKEN";
	case 0x8018:return "ERROR_ARC_FILE_OPEN";
	case 0x8019:return "ERROR_NOT_ARC_FILE";
	case 0x801A:return "ERROR_CANNOT_READ";
	case 0x801B:return "ERROR_FILE_STYLE";
	case 0x801C:return "ERROR_COMMAND_NAME";
	case 0x801D:return "ERROR_MORE_HEAP_MEMORY";
	case 0x801E:return "ERROR_ENOUGH_MEMORY";
	case 0x801F:return "ERROR_ALREADY_RUNNING";
	case 0x8020:return "ERROR_USER_CANCEL";
	case 0x8021:return "ERROR_HARC_ISNOT_OPENED";
	case 0x8022:return "ERROR_NOT_SEARCH_MODE";
	case 0x8023:return "ERROR_NOT_SUPPORT";
	case 0x8024:return "ERROR_TIME_STAMP";
	case 0x8025:return "ERROR_TMP_OPEN";
	case 0x8026:return "ERROR_LONG_FILE_NAME";
	case 0x8027:return "ERROR_ARC_READ_ONLY";
	case 0x8028:return "ERROR_SAME_NAME_FILE";
	case 0x8029:return "ERROR_NOT_FIND_ARC_FILE";
	case 0x802A:return "ERROR_RESPONSE_READ";
	case 0x802B:return "ERROR_NOT_FILENAME";
	case 0x802C:return "ERROR_TMP_COPY";
	case 0x802D:return "ERROR_EOF";
	case 0x802E:return "ERROR_ADD_TO_LARC";
	case 0x802F:return "ERROR_TMP_BACK_SPACE";
	case 0x8030:return "ERROR_SHARING";
	case 0x8031:return "ERROR_NOT_FIND_FILE";
	case 0x8032:return "ERROR_LOG_FILE";
	case 0x8033:return "ERROR_NO_DEVICE";
	case 0x8034:return "ERROR_GET_ATTRIBUTES";
	case 0x8035:return "ERROR_SET_ATTRIBUTES";
	case 0x8036:return "ERROR_GET_INFORMATION";
	case 0x8037:return "ERROR_GET_POINT";
	case 0x8038:return "ERROR_SET_POINT";
	case 0x8039:return "ERROR_CONVERT_TIME";
	case 0x803A:return "ERROR_GET_TIME";
	case 0x803B:return "ERROR_SET_TIME";
	case 0x803C:return "ERROR_CLOSE_FILE";
	case 0x803D:return "ERROR_HEAP_MEMORY";
	case 0x803E:return "ERROR_HANDLE";
	case 0x803F:return "ERROR_TIME_STAMP_RANGE";
	case 0x8040:return "ERROR_MAKE_ARCHIVE";
	default:    return "ERROR_UNKNOWN";
	}
}

static int CALLBACK __ki__ofp( HWND w, UINT m, LPARAM l, LPARAM d )
{
	if( m==BFFM_INITIALIZED && d )
		::SendMessage( w, BFFM_SETSELECTION, TRUE, d );
	return 0;
}

bool GetFolderDlg( char* buf, HWND par, const char* title, const char* def )
{
	// Zbg
	BROWSEINFO bi;
	ZeroMemory( &bi, sizeof(bi) );
	bi.hwndOwner      = par;
	bi.pszDisplayName = buf;
	bi.lpszTitle      = title;
	bi.ulFlags        = BIF_RETURNONLYFSDIRS | BIF_DONTGOBELOWDOMAIN;
	bi.lpfn           = __ki__ofp;
	bi.lParam         = (long)def;

	// _CAO\
	ITEMIDLIST* id = ::SHBrowseForFolder( &bi );
	if( id==NULL )
		return false;
	::SHGetPathFromIDList( id, buf );
	app().ShellFree( id );

	// I
	return true;
}

//---------------------------------------------------------------------


class UdDlg : public Dlg
{
public:
	UdDlg() : Dlg( IDD_MAIN )
	{
	}

private:
	UINT m_iDirIcon;

	void on_init()
	{
		// ̂ő剻j[폜
		const HMENU sysm = ::GetSystemMenu( hwnd(), FALSE );
		::DeleteMenu( sysm, SC_SIZE,     MF_BYCOMMAND );
		::DeleteMenu( sysm, SC_MAXIMIZE, MF_BYCOMMAND );

		// _CAÕACRƂ
		this->SendMsg( WM_SETICON, ICON_BIG, (LPARAM)::LoadImage(
			app().hinst(), MAKEINTRESOURCE(IDI_MAIN),
			IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR
		));
		this->SendMsg( WM_SETICON, ICON_SMALL, (LPARAM)::LoadImage(
			app().hinst(), MAKEINTRESOURCE(IDI_MAIN),
			IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR
		));

		// R{{bNXDLLZbg
		for( int i=DLL_BEGIN; i<DLL_END; i++ )
			SendMsgToItem( IDC_DLLNAME, CB_ADDSTRING, 0,
				(LPARAM)g_DllNameList[i] );

		// Xg
		char tmp[MAX_PATH];
		::GetWindowsDirectory( tmp, MAX_PATH );
		SHFILEINFO sfi;
		HIMAGELIST hImS = (HIMAGELIST)::SHGetFileInfo( tmp, 0, &sfi, sizeof(sfi), SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_SMALLICON );
		SendMsgToItem( IDC_DIRLIST, LVM_SETIMAGELIST, LVSIL_SMALL, (LPARAM)hImS );
		m_iDirIcon = sfi.iIcon;

		// JgfBNg
		::GetCurrentDirectory( MAX_PATH, tmp );
		ChangeCurDir(tmp);
	}

	void on_destroy()
	{
		SendMsgToItem( IDC_DIRLIST, LVM_SETIMAGELIST, LVSIL_SMALL );
	}

	bool on_ok()
	{
		char dll[MAX_PATH], api[MAX_PATH], cur[MAX_PATH];
		char* cmd = new char [SendMsgToItem(IDC_CMD,WM_GETTEXTLENGTH)+1];

		SendMsgToItem( IDC_DLLNAME, WM_GETTEXT, MAX_PATH, (LPARAM)dll );
		SendMsgToItem( IDC_APINAME, WM_GETTEXT, MAX_PATH, (LPARAM)api );
		SendMsgToItem( IDC_CMD    , WM_GETTEXT,0x7fffffff,(LPARAM)cmd );
		SendMsgToItem( IDC_CUR    , WM_GETTEXT, MAX_PATH, (LPARAM)cur );
		DoCommand( dll,api,cmd,cur );

		delete [] cmd;
		return false;
	}

	bool on_command( UINT cmd, UINT id, HWND ctrl )
	{
		if( cmd==CBN_EDITCHANGE || cmd==CBN_SELCHANGE )
		{
			on_combobox_change( cmd==CBN_SELCHANGE );
			return true;
		}
		else if( id==IDC_REF )
		{
			char cur[MAX_PATH];
			SendMsgToItem( IDC_CUR, WM_GETTEXT, MAX_PATH, (LPARAM)cur );
			if( GetFolderDlg( cur, hwnd(), "fBNgIł", cur ) )
			{
				ChangeCurDir(cur);
			}
			return true;
		}
		return false;
	}

	bool on_message( UINT msg, WPARAM wp, LPARAM lp )
	{
		if( wp==IDC_DIRLIST )
		{
			NMHDR* phdr=(NMHDR*)lp;
			if( phdr->code==NM_DBLCLK )
			{
				on_dblclk_dirlist();
				return true;
			}
		}
		return false;
	}

	int GetDllNumber( const char* name )
	{
		for( int i=DLL_BEGIN; i<DLL_END; i++ )
			if( strsamei(name,g_DllNameList[i]) )
				return i;
		return DLL_END;
	}

	void on_combobox_change( bool select )
	{
		char tmp[MAX_PATH];
		if( select )
		{
			int n = SendMsgToItem( IDC_DLLNAME, CB_GETCURSEL );
			SendMsgToItem( IDC_DLLNAME, CB_GETLBTEXT, n, (LPARAM)tmp );
		}
		else
		{
			SendMsgToItem( IDC_DLLNAME, WM_GETTEXT, MAX_PATH, (LPARAM)tmp );
		}
		SendMsgToItem( IDC_APINAME, WM_SETTEXT, 0,
			(LPARAM)g_ApiNameList[ GetDllNumber(tmp) ] );
	}

	void on_dblclk_dirlist() 
	{
		// t@C_uNbNƂ̔I
		// tH_JgύXAt@CR}hCɒǉ

		char tmp[MAX_PATH], cur[MAX_PATH];
		SendMsgToItem( IDC_CUR, WM_GETTEXT, MAX_PATH, (LPARAM)cur );

		char buf[MAX_PATH];
		LVITEM it;
		it.mask = LVIF_STATE;
		it.iSubItem = 0;
		it.pszText = buf;
		it.cchTextMax = MAX_PATH;
		it.stateMask = LVIS_SELECTED;
		for( it.iItem=0; SendMsgToItem( IDC_DIRLIST, LVM_GETITEM, 0, (LPARAM)&it ); it.iItem++ )
			if( LVIS_SELECTED&it.state )
			{
				it.mask |= LVIF_TEXT;
				SendMsgToItem( IDC_DIRLIST, LVM_GETITEM, 0, (LPARAM)&it );

				if( strsame(buf," <. > ") )
				{
					ChangeCurDir(cur);
				}
				else if( strsame(buf," <..> ") )
				{
					::lstrcpy( tmp, cur );
					::lstrcat( tmp, ".." );
					ChangeCurDir(tmp);
				}
				else if( buf[0]=='<' )
				{
					::lstrcpy( tmp, cur );
					::lstrcat( tmp, buf+1 );
					tmp[ ::lstrlen(tmp)-1 ]='\0';
					ChangeCurDir(tmp);
				}
				else
				{
					SendMsgToItem( IDC_CMD, WM_GETTEXT, MAX_PATH, (LPARAM)tmp );
					::lstrcat( tmp, buf );
					SendMsgToItem( IDC_CMD, WM_SETTEXT, 0, (LPARAM)tmp );
				}
				break;
			}
	}

	void ChangeCurDir( char* _path )
	{
		::SetCurrentDirectory(_path);

		char path[MAX_PATH],tmp[MAX_PATH];
		::GetCurrentDirectory(MAX_PATH,path);
		addslash(path);
		SendMsgToItem( IDC_CUR, WM_SETTEXT, 0, (LPARAM)path );

		while( ListView_DeleteItem(item(IDC_DIRLIST),0) );

		SHFILEINFO sfi;
		LVITEM lv;
		lv.mask     = LVIF_TEXT | LVIF_IMAGE;
		lv.iItem    = 0;
		lv.iSubItem = 0;

		WIN32_FIND_DATA fd;
		HANDLE h = ::FindFirstFile( "*.*", &fd );
		if( h != INVALID_HANDLE_VALUE )
		{
			do
			{
				if( fd.cFileName[0]=='.' && fd.cFileName[1]=='\0' )
				{
					lv.pszText = " <. > ";
					lv.iImage  = m_iDirIcon;
				}
				else if( fd.cFileName[0]=='.' && fd.cFileName[1]=='.' && fd.cFileName[2]=='\0' )
				{
					lv.pszText = " <..> ";
					lv.iImage  = m_iDirIcon;
				}
				else
				{
					::lstrcpy(tmp,path);
					::lstrcat(tmp,fd.cFileName);
					::SHGetFileInfo( tmp, 0, &sfi, sizeof(sfi), SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_SMALLICON );
					if( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
					{
						::wsprintf(tmp,"<%s>",fd.cFileName );
						lv.pszText = tmp;
					}
					else
						lv.pszText = fd.cFileName;
					lv.iImage  = sfi.iIcon;
				}

				ListView_InsertItem( item(IDC_DIRLIST), &lv );
			} while( ::FindNextFile( h, &fd ) );
			::FindClose( h );
		}
	}

	void DoCommand(
		const char* DLL, const char* API,
		const char* CMD, const char* DIR )
	{
		::SetCurrentDirectory( DIR );

		// AVFR}hȂsďI
		if( strsame( DLL, "SHELL" ) )
		{
			::ShellExecute( hwnd(), "open", API, CMD, DIR, SW_SHOWDEFAULT );
			return;
		}

		// DLL[h
		const int idll = GetDllNumber(DLL);
		HINSTANCE hdll = ::LoadLibrary(DLL);
		if( !hdll )
		{
			MsgBox( "ckk[hɎs" );
			return;
		}

		// ֐[h
		FARPROC f = ::GetProcAddress( hdll, API );
		const int APILEN = ::lstrlen(API);
		if( !f )
		{
			MsgBox( "֐擾Ɏs" );
			::FreeLibrary( hdll );
			return;
		}

		// Ăяo
		const int BUFSIZ = 65536;
		char* msg = new char [BUFSIZ];
		msg[0]='\0';

			//--GetVersion
			if( APILEN>=10 && strsame( API+APILEN-10, "GetVersion" ) )
			{
				WORD v=((DLL_VER)f)();
				::wsprintf( msg, "o[Wԍ %d.%02d", v/100,v%100 );
			}

			//--ɑDLL
			else if( idll == WINEX )
			{
				if( strsame( API, "WinExGetInfo" ) )
				{
					char tmp[MAX_PATH*2]="";
					if( CMD[2]!=':' )
						::lstrcpy( tmp, DIR );
					::lstrcat( tmp, CMD );
					GmdInfo info;
					((GMD_INF)f)(tmp,3000,&info,8);
					::lstrcpy( msg, "gq \"" );
					::lstrcat( msg, info.szFileEx );
					::lstrcat( msg, "\"\n\n" );
					::lstrcat( msg, info.szExInfo1 );
					::lstrcat( msg, "\n" );
					::lstrcat( msg, info.szExInfo2 );
				}
				else if( strsame( API, "WinExGetFileCRC32" ) || strsame( API, "WinExGetFileCRC" ) )
				{
					char tmp[MAX_PATH*2]="";
					if( CMD[2]!=':' )
						::lstrcpy( tmp, DIR );
					::lstrcat( tmp, CMD );
					::wsprintf( msg, "CRC %X", ((GMD_CRC)f)(tmp) );
				}
			}

			//--CheckArchive
			else if( APILEN>=12 && strsame( API+APILEN-12, "CheckArchive" ) )
			{
				if( ((DLL_CHK)f)(CMD,2) )
					::lstrcpy( msg, "ȏɂłB" );
				else
					::lstrcpy( msg, "jĂ邩Aɂł͂܂B" );
			}

			//--ConfigDialog
			else if( APILEN>=12 && strsame( API+APILEN-12, "ConfigDialog" ) )
			{
				((DLL_DLG)f)( hwnd(), msg, strsame(CMD,"pack")?2:1 );
			}

			//--Ish32.dll
			else if( idll == ISH )
			{
				int ret = ((DLL_ISH)f)( hwnd(), CMD );
				::lstrcpy( msg, "Ԓl " );
				::lstrcat( msg, error2str(ret) );
			}

			//--ʂ̃R}h
			else
			{
				int ret = ((DLL_CMD)f)( hwnd(), CMD, msg, BUFSIZ-100 );
				char tmp[100];
				::lstrcpy( tmp, "Ԓl " );
				::lstrcat( tmp, error2str(ret) );
				::lstrcat( tmp, "\n\n" );
				int len=::lstrlen(tmp);
				memmove( msg+len, msg, BUFSIZ-100 );
				memcpy( msg, tmp, len );
			}

		// I
		::FreeLibrary( hdll );
		if( msg[0]!='\0' )
			MsgBox( msg, DLL, MB_ICONINFORMATION );
		delete [] msg;
	}
};


//---------------------------------------------------------------------


class UdApp : public App
{
	void Run()
	{
		InitModule( CTL );

		UdDlg dlg;
		dlg.GoModal();
	}
};

APPLICATION_CLASS_IS( UdApp )
